<template>
  <div class="suggestions">
    <div class="suggestions-wrapper">
      <header
        v-if="!suggestionsNotEmpty"
        class="suggestions-header __bold">
        Ничего не найдено
      </header>
      <ul class="suggestions-grid">
        <li
          class="suggestions-grid-item"
          v-for="(suggestion, index) in suggestions"
          :key="index">
          <slot
            name="suggestion-item"
            :suggestion="suggestion"/>
        </li>
      </ul>
    </div>
  </div>
</template>

<script>

export default {
  name: 'AppSearchSuggestions',
  props: {
    suggestions: {
      type: Array,
      default() { return []; },
    },
  },
  computed: {
    suggestionsNotEmpty() {
      return this.suggestions && this.suggestions.length;
    },
  },
};
</script>

<style lang="postcss">
  .suggestions {
    position: absolute;
    z-index: 1;
    top: 100%;
    left: 0;
    right: 0;
    display: none;
    margin-top: -2px;
    width: 100%;
    max-height: 14.25rem;
    font-size: 0.75rem;
    color: var(--color-main);
    border-radius: 0 0 0.25rem 0.25rem;
    background-color: var(--bg-main);
    border: 1px solid var(--color-disabled);
    box-shadow: 0 2px 4px rgba(0, 0, 0, 0.1);
    overflow: hidden;

    &-wrapper {
      display: block;
      padding-bottom: 0.375rem;
      width: 100%;
      max-height: inherit;
      overflow-y: auto;
      overflow-x: hidden;
      -webkit-overflow-scrolling: touch;
    }

    &-header {
      padding: 0 0.875rem;
      height: 2.25rem;
      font-size: 0.75rem;
      line-height: 2.25rem;
    }

    @media screen and ( max-width: 980px ) {
      max-height: calc(100vh - 13rem);

      &-header {
        display: none;
      }
    }
  }

  .suggestion {
    display: flex;
    justify-content: space-between;
    align-items: center;
    height: 2.25rem;
    line-height: 1.4;
    color: currentColor;
    text-decoration: none;

    &-wrapper {
      display: flex;
      padding: 0 0.875rem;
      width: 100%;
      height: 100%;
    }

    &-unit {
      display: inline-flex;
      align-items: center;
      padding-right: 1.5rem;
      width: 100%;
      cursor: pointer;

      &._brand {
        width: 8rem;
      }

      &._number {
        width: 8rem;
      }

      &._name {
        margin-right: -1rem;
        width: calc(100% - 15rem);
      }

      & > .mark {
        background-color: transparent;
        font-weight: var(--font-weight-bold);
        color: var(--color-main);
      }
    }

    &:hover {
      color: var(--color-main);
      background-color: var(--bg-lightest);

      .suggestion-unit:after {
        background-image: linear-gradient(to left, var(--bg-lightest) 1rem, var(--bg-transparent));
      }
    }

    @media screen and ( min-width: 981px ) {
      &-unit {
        position: relative;
        white-space: nowrap;
        overflow: hidden;

        &:after {
          content: "";
          position: absolute;
          right: 0;
          top: 0;
          bottom: 0;
          width: 2rem;
          background-image: linear-gradient(to left, var(--bg-main) 1rem, var(--bg-transparent));
        }
      }
    }

    @media screen and ( max-width: 980px ) {
      padding: 0;
      height: auto;
      font-size: 1.125rem;
      color: var(--color-main-darkest);

      &-wrapper {
        display: block;
        padding: 1rem 1.25rem;
        height: auto;
      }

      &-unit {
        padding: 0;

        &._brand, &._number {
          display: inline;
          width: auto;
          font-weight: var(--font-weight-medium);
        }

        &._brand:after {
          content: ',';
          margin-left: -0.25rem;
        }

        &._name {
          display: block;
          margin: 0;
          padding-top: 0.375rem;
          width: 100%;
          font-size: 0.9275rem;
        }
      }
    }
  }

</style>
